package org.distributeme.test.fail.generated;
//CHECKSTYLE:OFF

import java.util.List;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.log4j.Logger;
import java.rmi.RemoteException;
import java.rmi.NotBoundException;
import org.distributeme.core.RegistryUtil;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import org.distributeme.core.ServiceDescriptor;
import org.distributeme.core.ServiceDescriptor.Protocol;
import org.distributeme.core.DiscoveryMode;
import org.distributeme.core.failing.FailingStrategy;
import org.distributeme.core.concurrencycontrol.ConcurrencyControlStrategy;
import org.distributeme.core.failing.FailDecision;
import org.distributeme.core.ClientSideCallContext;
import org.distributeme.core.exception.DistributemeRuntimeException;
import org.distributeme.core.exception.NoConnectionToServerException;
import org.distributeme.core.exception.ServiceUnavailableException;
import org.distributeme.core.Defaults;
import org.distributeme.core.interceptor.ClientSideRequestInterceptor;
import org.distributeme.core.interceptor.InterceptorRegistry;
import org.distributeme.core.interceptor.InterceptorResponse;
import org.distributeme.core.interceptor.InterceptionContext;
import org.distributeme.core.interceptor.InterceptionPhase;

public class RemoteFailableServiceStub implements org.distributeme.test.fail.FailableService{


	private volatile ConcurrentMap<String,RemoteFailableService> delegates = new ConcurrentHashMap<String,RemoteFailableService>();

	private DiscoveryMode discoveryMode = DiscoveryMode.AUTO;

	// ROUTER DECL V2
	// No class-wide-router set, skipping.

	// Method wide routers if applicable 
	private final org.distributeme.core.routing.Router failoverPrintAndStayRouter = createRouterInstance5();
	private final org.distributeme.core.routing.Router failoverPrintAndStayFoTenSecondsRouter = createRouterInstance6();
	// Method wide routers END 

	// ROUTER DECL V2 end

	// Failing
	// Class wide failing strategy 
	private FailingStrategy clazzWideFailingStrategy = new org.distributeme.core.failing.FailCall();

	private FailingStrategy failableMethodFailingStrategy = new org.distributeme.core.failing.FailCall();
	private FailingStrategy retryMethodFailingStrategy = new org.distributeme.core.failing.RetryCall();
	private FailingStrategy retryOnceMethodFailingStrategy = new org.distributeme.core.failing.RetryCallOnce();
	private FailingStrategy defaultMethodFailingStrategy = clazzWideFailingStrategy;
	private FailingStrategy failableEchoFailingStrategy_longvalue = new org.distributeme.core.failing.FailCall();
	private FailingStrategy retryEchoFailingStrategy_longvalue = new org.distributeme.core.failing.WaitOneSecondAndRetry();
	private FailingStrategy retryOnceEchoFailingStrategy_longvalue = new org.distributeme.core.failing.RetryCallOnce();
	private FailingStrategy failoverEchoFailingStrategy_longvalue = new org.distributeme.core.failing.Failover();
	private FailingStrategy failoverPrintFailingStrategy_javalangStringmessage = new org.distributeme.core.failing.Failover();
	private FailingStrategy failoverPrintAndStayFailingStrategy_javalangStringmessage = new org.distributeme.core.failing.Failover();
	private FailingStrategy failoverPrintAndStayFoTenSecondsFailingStrategy_javalangStringmessage = new org.distributeme.core.failing.FailoverAndReturnInTenSeconds();
	// Failing end

	// CONCURRENCY CONTROL
	// Class wide concurrency control strategy 
	private ConcurrencyControlStrategy clazzWideCCStrategy = Defaults.getDefaultConcurrencyControlStrategy();

	private ConcurrencyControlStrategy failableMethodCCStrategy = clazzWideCCStrategy;
	private ConcurrencyControlStrategy retryMethodCCStrategy = clazzWideCCStrategy;
	private ConcurrencyControlStrategy retryOnceMethodCCStrategy = clazzWideCCStrategy;
	private ConcurrencyControlStrategy defaultMethodCCStrategy = clazzWideCCStrategy;
	private ConcurrencyControlStrategy failableEchoCCStrategy_longvalue = clazzWideCCStrategy;
	private ConcurrencyControlStrategy retryEchoCCStrategy_longvalue = clazzWideCCStrategy;
	private ConcurrencyControlStrategy retryOnceEchoCCStrategy_longvalue = clazzWideCCStrategy;
	private ConcurrencyControlStrategy failoverEchoCCStrategy_longvalue = clazzWideCCStrategy;
	private ConcurrencyControlStrategy failoverPrintCCStrategy_javalangStringmessage = clazzWideCCStrategy;
	private ConcurrencyControlStrategy failoverPrintAndStayCCStrategy_javalangStringmessage = clazzWideCCStrategy;
	private ConcurrencyControlStrategy failoverPrintAndStayFoTenSecondsCCStrategy_javalangStringmessage = clazzWideCCStrategy;
	// CONCURRENCY CONTROL end

	public RemoteFailableServiceStub(){
		discoveryMode = DiscoveryMode.AUTO;
	}

	private ServiceDescriptor manuallySetDescriptor;
	private RemoteFailableService manuallySetTarget;

	public RemoteFailableServiceStub(ServiceDescriptor target){
		discoveryMode = DiscoveryMode.MANUAL;
		manuallySetDescriptor = target;
		try{
			manuallySetTarget = lookup(manuallySetDescriptor);
		}catch(NoConnectionToServerException e){
			throw new IllegalStateException("Can not resolve manually set reference", e);
		}
	}

	public void failableMethod(){
		failableMethod((ClientSideCallContext)null);
	} //...public void failableMethod()

	private void failableMethod(org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failableMethod");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failableMethodCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failableMethod( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failableMethodCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failableMethodFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					failableMethod(diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					failableMethod(diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void retryMethod(){
		retryMethod((ClientSideCallContext)null);
	} //...public void retryMethod()

	private void retryMethod(org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("retryMethod");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		retryMethodCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).retryMethod( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			retryMethodCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = retryMethodFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					retryMethod(diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					retryMethod(diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void retryOnceMethod(){
		retryOnceMethod((ClientSideCallContext)null);
	} //...public void retryOnceMethod()

	private void retryOnceMethod(org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("retryOnceMethod");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		retryOnceMethodCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).retryOnceMethod( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			retryOnceMethodCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = retryOnceMethodFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					retryOnceMethod(diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					retryOnceMethod(diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void defaultMethod(){
		defaultMethod((ClientSideCallContext)null);
	} //...public void defaultMethod()

	private void defaultMethod(org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("defaultMethod");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		defaultMethodCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).defaultMethod( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			defaultMethodCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = defaultMethodFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					defaultMethod(diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					defaultMethod(diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public long failableEcho(long value){
		return failableEcho(value, (ClientSideCallContext)null);
	} //...public long failableEcho(long value)

	private long failableEcho(long value, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failableEcho");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failableEchoCCStrategy_longvalue.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(value);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return ((Long)interceptorResponse.getReturnValue()).longValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			value = ((Long)diMeParameters.get(0)).longValue();
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failableEcho(value,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return ((Long)__fromServerSide.get(0)).longValue();
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failableEchoCCStrategy_longvalue.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return ((Long)interceptorResponse.getReturnValue()).longValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return ((Long)__fromServerSide.get(0)).longValue();
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failableEchoFailingStrategy_longvalue.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return failableEcho(value, diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return failableEcho(value, diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public long retryEcho(long value){
		return retryEcho(value, (ClientSideCallContext)null);
	} //...public long retryEcho(long value)

	private long retryEcho(long value, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("retryEcho");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		retryEchoCCStrategy_longvalue.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(value);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return ((Long)interceptorResponse.getReturnValue()).longValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			value = ((Long)diMeParameters.get(0)).longValue();
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).retryEcho(value,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return ((Long)__fromServerSide.get(0)).longValue();
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			retryEchoCCStrategy_longvalue.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return ((Long)interceptorResponse.getReturnValue()).longValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return ((Long)__fromServerSide.get(0)).longValue();
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = retryEchoFailingStrategy_longvalue.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return retryEcho(value, diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return retryEcho(value, diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public long retryOnceEcho(long value){
		return retryOnceEcho(value, (ClientSideCallContext)null);
	} //...public long retryOnceEcho(long value)

	private long retryOnceEcho(long value, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("retryOnceEcho");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		retryOnceEchoCCStrategy_longvalue.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(value);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return ((Long)interceptorResponse.getReturnValue()).longValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			value = ((Long)diMeParameters.get(0)).longValue();
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).retryOnceEcho(value,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return ((Long)__fromServerSide.get(0)).longValue();
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			retryOnceEchoCCStrategy_longvalue.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return ((Long)interceptorResponse.getReturnValue()).longValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return ((Long)__fromServerSide.get(0)).longValue();
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = retryOnceEchoFailingStrategy_longvalue.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return retryOnceEcho(value, diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return retryOnceEcho(value, diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public long failoverEcho(long value){
		return failoverEcho(value, (ClientSideCallContext)null);
	} //...public long failoverEcho(long value)

	private long failoverEcho(long value, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failoverEcho");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failoverEchoCCStrategy_longvalue.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(value);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return ((Long)interceptorResponse.getReturnValue()).longValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			value = ((Long)diMeParameters.get(0)).longValue();
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failoverEcho(value,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return ((Long)__fromServerSide.get(0)).longValue();
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failoverEchoCCStrategy_longvalue.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return ((Long)interceptorResponse.getReturnValue()).longValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return ((Long)__fromServerSide.get(0)).longValue();
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failoverEchoFailingStrategy_longvalue.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return failoverEcho(value, diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return failoverEcho(value, diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void failoverPrint(java.lang.String message){
		failoverPrint(message, (ClientSideCallContext)null);
	} //...public void failoverPrint(java.lang.String message)

	private void failoverPrint(java.lang.String message, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failoverPrint");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failoverPrintCCStrategy_javalangStringmessage.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(message);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			message = (java.lang.String) diMeParameters.get(0);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failoverPrint(message,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failoverPrintCCStrategy_javalangStringmessage.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failoverPrintFailingStrategy_javalangStringmessage.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					failoverPrint(message, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					failoverPrint(message, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void failoverPrintAndStay(java.lang.String message){
		failoverPrintAndStay(message, (ClientSideCallContext)null);
	} //...public void failoverPrintAndStay(java.lang.String message)

	private void failoverPrintAndStay(java.lang.String message, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failoverPrintAndStay");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failoverPrintAndStayCCStrategy_javalangStringmessage.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(message);
		diMeCallContext.setParameters(diMeParameters);
		diMeCallContext.setServiceId(failoverPrintAndStayRouter.getServiceIdForCall(diMeCallContext));
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			message = (java.lang.String) diMeParameters.get(0);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failoverPrintAndStay(message,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failoverPrintAndStayCCStrategy_javalangStringmessage.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failoverPrintAndStayFailingStrategy_javalangStringmessage.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					failoverPrintAndStay(message, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					failoverPrintAndStay(message, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void failoverPrintAndStayFoTenSeconds(java.lang.String message){
		failoverPrintAndStayFoTenSeconds(message, (ClientSideCallContext)null);
	} //...public void failoverPrintAndStayFoTenSeconds(java.lang.String message)

	private void failoverPrintAndStayFoTenSeconds(java.lang.String message, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("failoverPrintAndStayFoTenSeconds");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(FailableServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		failoverPrintAndStayFoTenSecondsCCStrategy_javalangStringmessage.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(message);
		diMeCallContext.setParameters(diMeParameters);
		diMeCallContext.setServiceId(failoverPrintAndStayFoTenSecondsRouter.getServiceIdForCall(diMeCallContext));
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			message = (java.lang.String) diMeParameters.get(0);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).failoverPrintAndStayFoTenSeconds(message,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			failoverPrintAndStayFoTenSecondsCCStrategy_javalangStringmessage.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = failoverPrintAndStayFoTenSecondsFailingStrategy_javalangStringmessage.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					failoverPrintAndStayFoTenSeconds(message, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					failoverPrintAndStayFoTenSeconds(message, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}


	private void notifyDelegateFailed(){
		notifyDelegateFailed(FailableServiceConstants.getServiceId());
	}

	private void notifyDelegateFailed(String serviceId){
		if (serviceId!=null)
			delegates.remove(serviceId);
	}

	private RemoteFailableService getDelegate() throws NoConnectionToServerException{
		if (discoveryMode==DiscoveryMode.MANUAL)
			return manuallySetTarget;
		return getDelegate(FailableServiceConstants.getServiceId());
	}

	private RemoteFailableService getDelegate(String serviceId) throws NoConnectionToServerException{
		// if no serviceid is provided, fallback to default resolve with manual mode
		if (serviceId==null)
			return getDelegate();
		RemoteFailableService delegate = delegates.get(serviceId);
		if (delegate==null){
			try{
				delegate = lookup(serviceId);
				delegates.putIfAbsent(serviceId, delegate);
			}catch(Exception e){
			// //TODO - generate and throw typed exception.
				throw new NoConnectionToServerException("Couldn't lookup delegate because: "+e.getMessage()+" at "+RegistryUtil.describeRegistry(), e);
			}//try
		} //...first if (del==null) 
		return delegate;
	} //...fun

	private RemoteFailableService lookup(String serviceId) throws NoConnectionToServerException{
		// //first we need to lookup target host.
		ServiceDescriptor toLookup = new ServiceDescriptor(Protocol.RMI, serviceId);
		ServiceDescriptor targetService = RegistryUtil.resolve(toLookup);
		if (targetService==null)
			throw new RuntimeException("Can't resolve host for an instance of "+FailableServiceConstants.getServiceId());
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(targetService.getHost(), targetService.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+targetService+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for an instance of "+FailableServiceConstants.getServiceId());
		}
		try{
			return (RemoteFailableService) registry.lookup(serviceId);
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}
	}

	private RemoteFailableService lookup(ServiceDescriptor serviceDescriptor) throws NoConnectionToServerException{
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(serviceDescriptor.getHost(), serviceDescriptor.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+serviceDescriptor+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for "+serviceDescriptor);
		}
		try{
			return (RemoteFailableService) registry.lookup(serviceDescriptor.getServiceId());
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}
	}

	private DistributemeRuntimeException mapException(Exception in){
		if (in instanceof DistributemeRuntimeException)
			return (DistributemeRuntimeException) in;
		if (in instanceof RemoteException)
			return new ServiceUnavailableException ("Service unavailable due to rmi failure: "+in.getMessage(), in);
		return new ServiceUnavailableException("Unexpected exception: "+in.getMessage()+" " + in.getClass().getName(), in);
	}
	private org.distributeme.core.routing.Router createRouterInstance5(){
		org.distributeme.core.routing.Router router = new org.distributeme.core.failing.Failover();
		router.customize("");
		return router;
	}
	private org.distributeme.core.routing.Router createRouterInstance6(){
		org.distributeme.core.routing.Router router = new org.distributeme.core.failing.FailoverAndReturnInTenSeconds();
		router.customize("");
		return router;
	}
}
