package org.distributeme.test.roundrobin.generated;
//CHECKSTYLE:OFF

import java.util.List;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.log4j.Logger;
import java.rmi.RemoteException;
import java.rmi.NotBoundException;
import org.distributeme.core.RegistryUtil;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import org.distributeme.core.ServiceDescriptor;
import org.distributeme.core.ServiceDescriptor.Protocol;
import org.distributeme.core.DiscoveryMode;
import org.distributeme.core.failing.FailingStrategy;
import org.distributeme.core.concurrencycontrol.ConcurrencyControlStrategy;
import org.distributeme.core.failing.FailDecision;
import org.distributeme.core.ClientSideCallContext;
import org.distributeme.core.exception.DistributemeRuntimeException;
import org.distributeme.core.exception.NoConnectionToServerException;
import org.distributeme.core.exception.ServiceUnavailableException;
import org.distributeme.core.Defaults;
import org.distributeme.core.interceptor.ClientSideRequestInterceptor;
import org.distributeme.core.interceptor.InterceptorRegistry;
import org.distributeme.core.interceptor.InterceptorResponse;
import org.distributeme.core.interceptor.InterceptionContext;
import org.distributeme.core.interceptor.InterceptionPhase;

public class RemoteRoundRobinServiceStub implements org.distributeme.test.roundrobin.RoundRobinService{


	private volatile ConcurrentMap<String,RemoteRoundRobinService> delegates = new ConcurrentHashMap<String,RemoteRoundRobinService>();

	private DiscoveryMode discoveryMode = DiscoveryMode.AUTO;

	// ROUTER DECL V2
	// Class wide router 
	private final org.distributeme.core.routing.Router clazzWideRouter = createRouterInstance4();

	// Method wide routers if applicable 
	// Method wide routers END 

	// ROUTER DECL V2 end

	// Failing
	// Class wide failing strategy 
	private FailingStrategy clazzWideFailingStrategy = Defaults.getDefaultFailingStrategy();

	private FailingStrategy addFailingStrategy_inta_intb = clazzWideFailingStrategy;
	private FailingStrategy getRandomIdFailingStrategy = clazzWideFailingStrategy;
	private FailingStrategy printFailingStrategy_javalangStringparameter = clazzWideFailingStrategy;
	// Failing end

	// CONCURRENCY CONTROL
	// Class wide concurrency control strategy 
	private ConcurrencyControlStrategy clazzWideCCStrategy = Defaults.getDefaultConcurrencyControlStrategy();

	private ConcurrencyControlStrategy addCCStrategy_inta_intb = clazzWideCCStrategy;
	private ConcurrencyControlStrategy getRandomIdCCStrategy = clazzWideCCStrategy;
	private ConcurrencyControlStrategy printCCStrategy_javalangStringparameter = clazzWideCCStrategy;
	// CONCURRENCY CONTROL end

	public RemoteRoundRobinServiceStub(){
		discoveryMode = DiscoveryMode.AUTO;
	}

	private ServiceDescriptor manuallySetDescriptor;
	private RemoteRoundRobinService manuallySetTarget;

	public RemoteRoundRobinServiceStub(ServiceDescriptor target){
		discoveryMode = DiscoveryMode.MANUAL;
		manuallySetDescriptor = target;
		try{
			manuallySetTarget = lookup(manuallySetDescriptor);
		}catch(NoConnectionToServerException e){
			throw new IllegalStateException("Can not resolve manually set reference", e);
		}
	}

	public int add(int a, int b){
		return add(a, b, (ClientSideCallContext)null);
	} //...public int add(int a, int b)

	private int add(int a, int b, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("add");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(RoundRobinServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		addCCStrategy_inta_intb.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(a);
		diMeParameters.add(b);
		diMeCallContext.setParameters(diMeParameters);
		diMeCallContext.setServiceId(clazzWideRouter.getServiceIdForCall(diMeCallContext));
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return ((Integer)interceptorResponse.getReturnValue()).intValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			a = ((Integer)diMeParameters.get(0)).intValue();
			b = ((Integer)diMeParameters.get(1)).intValue();
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).add(a, b,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return ((Integer)__fromServerSide.get(0)).intValue();
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			addCCStrategy_inta_intb.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return ((Integer)interceptorResponse.getReturnValue()).intValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return ((Integer)__fromServerSide.get(0)).intValue();
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = addFailingStrategy_inta_intb.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return add(a, b, diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return add(a, b, diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public java.lang.String getRandomId(){
		return getRandomId((ClientSideCallContext)null);
	} //...public java.lang.String getRandomId()

	private java.lang.String getRandomId(org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("getRandomId");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(RoundRobinServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		getRandomIdCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		diMeCallContext.setServiceId(clazzWideRouter.getServiceIdForCall(diMeCallContext));
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return (java.lang.String) interceptorResponse.getReturnValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).getRandomId( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return (java.lang.String) __fromServerSide.get(0);
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			getRandomIdCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return (java.lang.String) interceptorResponse.getReturnValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return (java.lang.String) __fromServerSide.get(0);
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = getRandomIdFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return getRandomId(diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return getRandomId(diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void print(java.lang.String parameter){
		print(parameter, (ClientSideCallContext)null);
	} //...public void print(java.lang.String parameter)

	private void print(java.lang.String parameter, org.distributeme.core.ClientSideCallContext diMeCallContext){
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("print");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(RoundRobinServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		printCCStrategy_javalangStringparameter.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(parameter);
		diMeCallContext.setParameters(diMeParameters);
		diMeCallContext.setServiceId(clazzWideRouter.getServiceIdForCall(diMeCallContext));
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			parameter = (java.lang.String) diMeParameters.get(0);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).print(parameter,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			printCCStrategy_javalangStringparameter.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = printFailingStrategy_javalangStringparameter.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					print(parameter, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					print(parameter, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}


	private void notifyDelegateFailed(){
		notifyDelegateFailed(RoundRobinServiceConstants.getServiceId());
	}

	private void notifyDelegateFailed(String serviceId){
		if (serviceId!=null)
			delegates.remove(serviceId);
	}

	private RemoteRoundRobinService getDelegate() throws NoConnectionToServerException{
		if (discoveryMode==DiscoveryMode.MANUAL)
			return manuallySetTarget;
		return getDelegate(RoundRobinServiceConstants.getServiceId());
	}

	private RemoteRoundRobinService getDelegate(String serviceId) throws NoConnectionToServerException{
		// if no serviceid is provided, fallback to default resolve with manual mode
		if (serviceId==null)
			return getDelegate();
		RemoteRoundRobinService delegate = delegates.get(serviceId);
		if (delegate==null){
			try{
				delegate = lookup(serviceId);
				delegates.putIfAbsent(serviceId, delegate);
			}catch(Exception e){
			// //TODO - generate and throw typed exception.
				throw new NoConnectionToServerException("Couldn't lookup delegate because: "+e.getMessage()+" at "+RegistryUtil.describeRegistry(), e);
			}//try
		} //...first if (del==null) 
		return delegate;
	} //...fun

	private RemoteRoundRobinService lookup(String serviceId) throws NoConnectionToServerException{
		// //first we need to lookup target host.
		ServiceDescriptor toLookup = new ServiceDescriptor(Protocol.RMI, serviceId);
		ServiceDescriptor targetService = RegistryUtil.resolve(toLookup);
		if (targetService==null)
			throw new RuntimeException("Can't resolve host for an instance of "+RoundRobinServiceConstants.getServiceId());
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(targetService.getHost(), targetService.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+targetService+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for an instance of "+RoundRobinServiceConstants.getServiceId());
		}
		try{
			return (RemoteRoundRobinService) registry.lookup(serviceId);
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}
	}

	private RemoteRoundRobinService lookup(ServiceDescriptor serviceDescriptor) throws NoConnectionToServerException{
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(serviceDescriptor.getHost(), serviceDescriptor.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+serviceDescriptor+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for "+serviceDescriptor);
		}
		try{
			return (RemoteRoundRobinService) registry.lookup(serviceDescriptor.getServiceId());
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}
	}

	private DistributemeRuntimeException mapException(Exception in){
		if (in instanceof DistributemeRuntimeException)
			return (DistributemeRuntimeException) in;
		if (in instanceof RemoteException)
			return new ServiceUnavailableException ("Service unavailable due to rmi failure: "+in.getMessage(), in);
		return new ServiceUnavailableException("Unexpected exception: "+in.getMessage()+" " + in.getClass().getName(), in);
	}
	private org.distributeme.core.routing.Router createRouterInstance4(){
		org.distributeme.core.routing.Router router = new org.distributeme.core.routing.RoundRobinRouter();
		router.customize("3");
		return router;
	}
}
